<?php
// simple backup script
//
// Faster and more up to date incrimental backups can be made using the bin log. This is highly recommended for large systems.
//    See discussion of this practice here: http://dev.mysql.com/doc/refman/4.1/en/backup-strategy-example.html
// NOTE: Because the search table is myisam, it won't be in the same temporal point as the other tables at the point of backup.
//       (--single-transaction only applies to innodb. a similar flag for myisam is --locktables) 
//       Eventually there will be a script to regenerate the search table from the other tables.
//
// 1] Fill out db name, user, password, and host below
// 2] Specify full path of backup directory, with leading and trailing slash. Example: /tmp/
// 3] Invoke (say, with cron, nightly. Or hourly.) with: php -f /path/to/backup.php

	$DB_NAME = 'lyceum';
	$DB_USER= 'root';
	$DB_PASSWORD= '';
	$DB_HOST= 'localhost';
	$BACKUPDIR = '/tmp/';
// STOP EDITING ///////////////////////////////////////////////////////////////////

$time = time();
$password = ''==$DB_PASSWORD ? '' : "-p$DB_PASSWORD ";
$command = 
	"mysqldump --opt -u$DB_USER " .
	$password .
	"--single-transaction $DB_NAME | gzip -c > '{$BACKUPDIR}'lyceum_'{$time}'.sql.gz"
;

exec($command);

?>
