<?php
// ** MySQL settings ** //
define('DB_NAME', 'lyceum');    // The name of the database
define('DB_USER', 'root');      // Your MySQL username
define('DB_PASSWORD', '');      // ...and password
define('DB_HOST', 'localhost'); // hostname or IP of database server (possibly 'localhost')

// You can have multiple installations in one database if you give each a unique prefix
$table_prefix  = '';     // Only numbers, letters, and underscores please!


define('PROTOCOL', 'http://');
// The web path to the base of lyceum (where portal.php is sitting), with NO TRAILING SLASH
// Something like '' or '/lyceum' or '/src/lyceum'
define('WEBROOT', '');
// The web path to the base of lyceum (where portal.php is sitting), with NO TRAILING SLASH.
// Only change this if you are doing a non-typical installation, otherwise it will happily be the same
// as WEBROOT
define('SRCROOT', WEBROOT);

// The IP address or equivalent domain name of the server (MUST have 1 or more periods - 'localhost' will not work!)
define('MAINDOMAIN', 'blogs.example.com');
define('DEFAULTBLOG', false);

// Sessions
//
// It is highly recommended that you set your own session path, so that other php applications
// on your server (including possibly those from other users on shared hosting) do not prematurely
// clear your session data. You must ensure that this directory exists and is writable 
// by the webserver. Here are two recommended paths for *nix and Windows: 
//   define('SESSIONPATH', '/tmp/blogs.example.com');   // *nix
//   define('SESSIONPATH', '\\TEMP\blogs.example.com'); // Windows
//
// Database sessions will be fully supported in Lyceum 1.1 and are currently experimental
//   define('DBSESSIONS', true);

//you probably want to leave these as they are
define('DEFAULT_PS', '/%year%/%monthnum%/%day%/%postname%/');
define('DEFAULT_TEMPLATE', 'default');
define('DEFAULT_STYLESHEET', 'default');

// Subdomain options
// See doc/Installation.txt and doc/Subdomains.txt for more info
define('SUBDOMAINS', false);

//log files
define('USELOGS', true); //If you are having problems installing on windows, make this 'false'
define('LOGDIR', '/tmp/'); //path MUST have trailing slash. example: /tmp/
define('SECURITYLOG', LOGDIR . 'lyceum_security_log');
define('TRACELOG', LOGDIR . 'lyceum_trace_log');
define('ERRORLOG', LOGDIR . 'lyceum_error_log');
define('QUERYLOG', LOGDIR . 'lyceum_query_log');
define('TOKENLOG', LOGDIR . 'lyceum_token_log');

// Change this to localize WordPress.  A corresponding MO file for the
// chosen language must be installed to wp-includes/languages.
// For example, install de.mo to wp-includes/languages and set WPLANG to 'de'
// to enable German language support.
define ('WPLANG', '');

//should lyceum NOT create an obfuscated filename for wp-comments-post.php at install time? (if you don't know what this means just leave it set to true)
define('SAVEWPCOMMENTS', true);

////////////////////////////////////////////////////////////////////////////////
// Debug options. If you aren't a developer or a tester, leave them as they are.

//this should be set to false for production
define('LYCEUMDEBUG', false);
define('LOGQUERIES', LYCEUMDEBUG);

// Allow installation to be overwritten from the web? (this is handy for developers who do frequent re-installs)
// THIS MUST BE FALSE FOR PRODUCTION
define('WEBREINSTALL', false);

//print trace information?
define('TRACE', LYCEUMDEBUG);

assert_options(ASSERT_CALLBACK, 'assert_handler');
assert_options(ASSERT_ACTIVE, LYCEUMDEBUG);//enable assert() evaluation
assert_options(ASSERT_WARNING, 0);//issue a PHP warning for each failed assertion
assert_options(ASSERT_QUIET_EVAL, 0);//disable error_reporting during assertion expression evaluation
assert_options(ASSERT_BAIL, 1);//terminate execution on failed assertions

ini_set('error_reporting', E_ALL ^ E_NOTICE );
ini_set('display_errors', '0');
ini_set('log_errors', '1');
ini_set('error_log', ERRORLOG);

//define('SITETITLE', 'Local Lyceum Development Installation');
//define('ADMINEMAIL', 'put your email address here');

/* That's all, stop editing! Happy blogging. */

require_once(PRIVATEROOT . 'wp-settings.php');
?>
