<?php
require('system-config.php');
require('../../lib/taglib.php');
$site_title = get_settings('site_title');

$myblogs = get_userblogs();
arrayify($myblogs);

// ===========================================================================
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<title><?php echo $site_title ?>: Lyceum System Settings</title>

	<link rel="stylesheet" href="<?php echo LURL ?>/wp-admin/wp-admin.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo LURL ?>/system-admin/lyceum.css" type="text/css" />

	<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_settings('blog_charset'); ?>" />
</head>


<body>

<div id="PageWrapper" class="AdminMain">

<?php require(ABSPATH . '/system-admin/lyceum-header.php'); ?>
	
	<hr />

	<!-- BEGIN: body -->
	<div id="BodyWrapper">

		<!-- BEGIN: main column -->
		<div id="MainColumn">

			<!-- BEGIN: main nav -->
			<ul id="MainNav">
				<li class="Selected"><span><a href="settings.php">System Settings</a></span></li>
				<li><span><a href="blog-management.php">Blogs</a></span></li>
				<li><span><a href="user-management.php">Users</a></span></li>
				<li><span><a href="systemplugins.php">Plugins</a></span></li>
				<li><span><a href="rewriterules.php">Apache Rewrite Rules</a></span></li>
</ul>
			<div class="ClearFix TabBorder"><!-- do not remove --></div>
			<!-- END: main nav -->

			<div class="wrap">
				<h2>Lyceum Config</h2>

<?php

function lyceum_settings_input($option, $inputrow){
	return
	_form(array('method'=>'post', 'action'=>'setoption.php', 'class'=>'lyceum_form'),
		tokeninput('setoption.php', $option) .
		_input(array('type'=>'hidden', 'name'=>'option', 'value'=>$option)) .

		_table(array('class'=>'FormTable'),
			_col(array('width'=>'20%')) .
			_col(array('width'=>'80%')) .

			_tbody(
				_tr( $inputrow )
	)));
}

function lyceum_settings_textual_input($option, $description, $documentation, $input){
	return lyceum_settings_input($option,
		_th(array('scope'=>'row'), _label(array('for'=>$option), $description)) .
		_td(
			$input .
			_input(array('type'=>'submit', 'value'=>'Submit', 'name'=>'submit', 'class'=>'Button' )) .
			( $documentation ? _div( array('class'=>"HelpText"), $documentation) : '')
		));
}

function lyceum_settings_text_input($option, $description, $documentation = false, $maxlength = false){
	return lyceum_settings_textual_input($option, $description, $documentation,
		_input( array( 'type'=>'text', 'name'=>'value', 'id'=>$option, 'maxlength'=>($maxlength ? $maxlength : '100'),
		               'value'=>get_option($option), 'class'=>'TextInput')));
};

function lyceum_settings_textarea_input($option, $description, $documentation){
	return lyceum_settings_textual_input($option, $description, $documentation,
		_textarea( array( 'name'=>'value', 'cols'=>'60', 'rows'=>'5', 'id'=>'slug_blacklist', 'class'=>'TextArea'),
		                  get_option($option)));
};

function lyceum_settings_boolean_input($option, $description, $documentation, $warning=false){
	return lyceum_settings_input($option,
		_th(array('scope'=>'row'),_span(array('class'=>'Label'), $description)) .
		_td(
			_ul(array( 'class'=>'HorizList Inputs'),
				_li(_input( array_merge(array('type'=>'radio', 'name'=>'value', 'id'=>$option.'_1', 'value'=>'1'), 
					(  get_option($option) ? array('checked'=>'checked') : array()))) . _label( array('for'=>$option.'_1'), 'Enabled')) .
				_li(_input( array_merge(array('type'=>'radio', 'name'=>'value', 'id'=>$option.'_0', 'value'=>'0'),
					( !get_option($option) ? array('checked'=>'checked') : array()))) . _label( array('for'=>$option.'_0'), 'Disabled'))
			) .
			_input( array('type'=>'submit', 'value'=>'Submit', 'name'=>'submit', 'class'=>'Button') ) .
			_div( array('class'=>'HelpText'), $documentation) .
			( $warning ? _div( array('class'=>'Note'), $warning) : '' )
		));
}

echo
lyceum_settings_text_input('site_title', 'Site Title') .
lyceum_settings_text_input('system_admin_email', 'System Admin email') .
lyceum_settings_text_input('wp-content_file_path', 'wp-content_file_path', 'The file path where individual blog uploads and cache are kept.', 200) .
lyceum_settings_text_input('fileupload_base_url', 'File upload base url', 'This needs to work with wp-content_file_path above.') .
lyceum_settings_text_input('system_charset', 'System character encoding') .
lyceum_settings_text_input('email_structure', 'email regex', 'Regular expression against which new email addresses must match (example: <strong>/.*@example\.tld/</strong>)') .
lyceum_settings_text_input('email_structure_error_message', 'email regex error', '(example: <strong>You must have a example.tld email address in order to make an account.</strong>)') .
lyceum_settings_textarea_input('slug_blacklist', 'Unregisterable Slugs', 'Comma-separated with no spaces.') .
lyceum_settings_textarea_input('username_blacklist', 'Unregisterable Usernames', 'Comma-separated with no spaces.') .
lyceum_settings_boolean_input('users_can_register', 'Open Registration', 'Allow users to register themselves for an account and blog. (Above regular expression still applies.)') .
lyceum_settings_boolean_input('users_can_create_blogs', 'Can users create blogs?', '') .
lyceum_settings_text_input('users_can_create_num_blogs', 'How many blogs can users create?', '0 means no limit') .
lyceum_settings_boolean_input('presentation_tab', 'User Customization', 'Allow users to change their blog\'s theme and adjust its settings.') .
lyceum_settings_textarea_input('new_user_welcome_message', 'New user welcome message', 'The message that will be emailed to a user upon account creation. If a user simultaneously registers and creates a blog, they will get both this message and the one below.') .
lyceum_settings_textarea_input('new_blog_welcome_message', 'New blog welcome message', 'The message that will be emailed to a user upon creation of a blog.') .
lyceum_settings_boolean_input('create_example_post', 'Create Example Post', 'Should an example blog post be created when a new blog is created?') .
lyceum_settings_text_input('example_post_title', 'Example post title', 'The title of the example post.') .
lyceum_settings_textarea_input('example_post_body', 'Example post body', 'The body of the example post.') .
lyceum_settings_boolean_input('create_example_page', 'Create Example Page', 'Should an example page be created when a new blog is created?') .
lyceum_settings_text_input('example_page_title', 'Example page title', 'The title of the example page.') .
lyceum_settings_textarea_input('example_page_body', 'Example page body', 'The body of the example page.') .
lyceum_settings_boolean_input('import_allowed', 'Import Scripts', 'Allow users to use the import scripts?', 'These scripts are not yet thoroughly tested and are therefore a potential security vulnerability.') .
lyceum_settings_boolean_input('gzipcompression', 'gzip Compression', 'Compress articles (gzip) if browsers ask for them.', 'This feature has not been thoroughly tested.') .
lyceum_settings_boolean_input('restrict_admin_ip', 'Restrict Admin IP', 'Restrict IP addresses from which an administrator may log in.', "<strong>BEFORE YOU TURN THIS ON:</strong> Make sure that your current IP address, <strong>{$_SERVER['REMOTE_ADDR']}</strong>, is in the list below.");
?>

<form method="post" action="adminip.php" class="lyceum_form">
	<?php echo tokeninput('adminip.php')?>

	<table class="FormTable">
		<col width="20%" />
		<col width="80%" />

		<tbody>
			<tr>
				<th scope="row"><label for="admin_ip">New Admin IP</label></th>
				<td>
					<input type="text" name="ip" id="admin_ip" maxlength="15" class="TextInput" />
					<input type="submit" value="Submit" name="submit" class="Button" />
				</td>
			</tr>

			<tr>
				<th scope="row">Current Admin IPs</th>
				<td>
					<ul>
<?php
$ips = get_admin_ips();
foreach($ips as $ip) {
?>
										<li><?php echo $ip ?></li>
<?php
}
?>
					</ul>
				</td>
			</tr>

		</tbody>
	</table>
</form>

			</div>

		</div>
		<!-- END: main column -->

	</div>
	<!-- END: body -->

	<hr />

<?php include(ABSPATH . 'wp-admin/admin-footer.php'); ?>

</div>


</body>

</html>
