<?php
// Here we keep the DB structure and option values

$wp_queries="CREATE TABLE $wpdb->categories (
  cat_ID int unsigned NOT NULL auto_increment,
  cat_name varchar(55) NOT NULL default '',
  category_nicename varchar(200) NOT NULL default '',
  category_description longtext NOT NULL default '',
  category_parent int NOT NULL default '0',
  category_count int NOT NULL default '0',
  PRIMARY KEY  (cat_ID),
  KEY category_nicename (category_nicename),
  blog mediumint unsigned NOT NULL default '0',
  KEY blog (blog,cat_ID),
  KEY cat_name (cat_name)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->comments (
  comment_ID int unsigned NOT NULL auto_increment,
  comment_post_ID int unsigned NOT NULL default '0',
  comment_author tinytext NOT NULL default '',
  comment_author_email varchar(100) NOT NULL default '',
  comment_author_url varchar(200) NOT NULL default '',
  comment_author_IP varchar(100) NOT NULL default '',
  comment_date datetime NOT NULL default '0000-00-00 00:00:00',
  comment_date_gmt datetime NOT NULL default '0000-00-00 00:00:00',
  comment_content text NOT NULL default '',
  comment_karma int(11) NOT NULL default '0',
  comment_approved enum('0','1','spam') NOT NULL default '1',
  comment_agent varchar(255) NOT NULL default '',
  comment_type varchar(20) NOT NULL default '',
  comment_parent int NOT NULL default '0',
  user_id int NOT NULL default '0',
  PRIMARY KEY  (comment_ID),
  KEY comment_approved (comment_approved),
  KEY comment_post_ID (comment_post_ID)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->linkcategories (
  cat_id int unsigned NOT NULL auto_increment,
  cat_name tinytext NOT NULL default '',
  auto_toggle enum('Y','N') NOT NULL default 'N',
  show_images enum('Y','N') NOT NULL default 'Y',
  show_description enum('Y','N') NOT NULL default 'N',
  show_rating enum('Y','N') NOT NULL default 'Y',
  show_updated enum('Y','N') NOT NULL default 'Y',
  sort_order varchar(64) NOT NULL default 'rand',
  sort_desc enum('Y','N') NOT NULL default 'N',
  text_before_link varchar(128) NOT NULL default '<li>',
  text_after_link varchar(128) NOT NULL default '<br />',
  text_after_all varchar(128) NOT NULL default '</li>',
  list_limit int(11) NOT NULL default '-1',
  PRIMARY KEY  (cat_id),
  blog mediumint unsigned NOT NULL default '0',
  KEY blog (blog,cat_ID),
  KEY cat_name (cat_name(5))
) ENGINE = InnoDB;
CREATE TABLE $wpdb->links (
  link_id int unsigned NOT NULL auto_increment,
  link_url varchar(255) NOT NULL default '',
  link_name varchar(255) NOT NULL default '',
  link_image varchar(255) NOT NULL default '',
  link_target varchar(25) NOT NULL default '',
  link_category int NOT NULL default '0',
  link_description varchar(255) NOT NULL default '',
  link_visible enum('Y','N') NOT NULL default 'Y',
  link_owner int(11) NOT NULL default '1',
  link_rating int(11) NOT NULL default '0',
  link_updated datetime NOT NULL default '0000-00-00 00:00:00',
  link_rel varchar(255) NOT NULL default '',
  link_notes mediumtext NOT NULL default '',
  link_rss varchar(255) NOT NULL default '',
  PRIMARY KEY  (link_id),
  KEY link_category (link_category),
  KEY link_visible (link_visible)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->options (
  option_id int unsigned NOT NULL auto_increment,
  blog_id int unsigned NOT NULL default '0',
  option_name varchar(64) NOT NULL default '',
  option_can_override enum('Y','N') NOT NULL default 'Y',
  option_type int(11) NOT NULL default '1',
  option_value longtext NOT NULL default '',
  option_width int(11) NOT NULL default '20',
  option_height int(11) NOT NULL default '8',
  option_description tinytext NOT NULL default '',
  option_admin_level int(11) NOT NULL default '1',
  autoload enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (option_id,blog_id,option_name),
  KEY option_name (option_name),
  option_domain enum('system','blog') NOT NULL default 'blog',
  blog mediumint unsigned NOT NULL default '0',
  UNIQUE blogdomainindex (blog, autoload, option_name),
  UNIQUE systemdomainindex (option_domain, option_name, blog)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->post2cat (
  rel_id int unsigned NOT NULL auto_increment,
  post_id int unsigned NOT NULL default '0',
  category_id int unsigned NOT NULL default '0',
  PRIMARY KEY  (rel_id),
  UNIQUE post_id (post_id,category_id),
  UNIQUE category_id (category_id,post_id)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->postmeta (
  meta_id int unsigned NOT NULL auto_increment,
  post_id int unsigned NOT NULL default '0',
  meta_key varchar(255) default NULL default '',
  meta_value longtext default '',
  PRIMARY KEY  (meta_id),
  KEY post_id (post_id),
  KEY meta_key (meta_key),
  KEY mainkey (post_id, meta_key)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->posts (
  ID int unsigned NOT NULL auto_increment,
  post_author mediumint unsigned NOT NULL default '0',
  post_date datetime NOT NULL default '0000-00-00 00:00:00',
  post_date_gmt datetime NOT NULL default '0000-00-00 00:00:00',
  post_content longtext NOT NULL default '',
  post_title text NOT NULL default '',
  post_category int(4) NOT NULL default '0',
  post_excerpt text NOT NULL default '',
  post_status enum('publish','draft','private','static','object','attachment') NOT NULL default 'publish',
  comment_status enum('open','closed','registered_only') NOT NULL default 'open',
  ping_status enum('open','closed') NOT NULL default 'open',
  post_password varchar(20) NOT NULL default '',
  post_name varchar(200) NOT NULL default '',
  to_ping text NOT NULL default '',
  pinged text NOT NULL default '',
  post_modified datetime NOT NULL default '0000-00-00 00:00:00',
  post_modified_gmt datetime NOT NULL default '0000-00-00 00:00:00',
  post_content_filtered text NOT NULL default '',
  post_parent int NOT NULL default '0',
  guid varchar(255) NOT NULL default '',
  menu_order int(11) NOT NULL default '0',
  post_type varchar(100) NOT NULL default '',
  post_mime_type varchar(100) NOT NULL default '',
  comment_count int NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY post_name (post_name),
  page_blog mediumint unsigned default NULL,
  KEY page_blog (page_blog),
  KEY post_parent (post_parent),
  KEY post_date (post_date),
  KEY main (post_status, post_author, post_date_gmt),
  KEY page (post_status, page_blog)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->users (
  ID mediumint unsigned NOT NULL auto_increment,
  user_login varchar(60) NOT NULL default '',
  user_pass varchar(64) NOT NULL default '',
  user_nicename varchar(50) NOT NULL default '',
  user_email varchar(100) NOT NULL default '',
  user_url varchar(100) NOT NULL default '',
  user_registered datetime NOT NULL default '0000-00-00 00:00:00',
  user_activation_key varchar(60) NOT NULL default '',
  user_status int(11) NOT NULL default '0',
  display_name varchar(250) NOT NULL default '',
  PRIMARY KEY  (ID),
  UNIQUE user_login_key (user_login),
  UNIQUE user_email (user_email),
  user_locked enum('0','1') NOT NULL default '0',
  user_admin enum('0','1') NOT NULL default '0'
) ENGINE = InnoDB;
CREATE TABLE $wpdb->usermeta (
  umeta_id int unsigned NOT NULL auto_increment,
  user_id int unsigned NOT NULL default '0',
  meta_key varchar(255) default NULL,
  meta_value longtext default '',
  PRIMARY KEY  (umeta_id),
  KEY user_id (user_id),
  KEY meta_key (meta_key),
  meta_domain enum('system','blog') NOT NULL default 'blog',
  blog mediumint unsigned default NULL,
  UNIQUE blogindex (blog, user_id, meta_key),
  KEY systemindex (meta_domain, user_id, meta_key)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->blogs (
  `id` mediumint unsigned NOT NULL auto_increment,
  `slug` varchar(60) unique NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` enum('active','deleted') NOT NULL default 'active',
  PRIMARY KEY  (`id`),
  UNIQUE mainkey (slug, id, status)
) ENGINE = InnoDB;
CREATE TABLE $wpdb->postsearch (
  `id` int unsigned NOT NULL auto_increment,
  `post_id` int unsigned NOT NULL default '0',
  `object_id` int unsigned NOT NULL default '0',
  `component` enum('title', 'content','comment') NOT NULL,
  `textdata` text NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY (`post_id`),
  FULLTEXT (`textdata`)
) ENGINE = MyIsam;
CREATE TABLE $wpdb->sessions (
  id varchar(32) NOT NULL default '',
  access int(10) unsigned,
  data text,
  PRIMARY KEY  (id)
) ENGINE = InnoDB
";

function populate_options() {
	global $wpdb;
	global $blog;
	assert(isset($blog));
	
	$old_umask = umask(0);

	$wpcontent = get_option('wp-content_file_path')."$blog/";

	//add_option('themes_file_path', $wpcontent."themes/");
	//add_option('themes_web_path', get_option('siteurl')."/wp-content/$blog/themes/");
	//add_option('plugins_file_path', $wpcontent."plugins/");
	add_option('uploads_file_path', $wpcontent."uploads/");
	add_option('uploads_web_path', get_option('fileupload_base_url')."$blog/uploads/");

	$stat = stat(get_option('wp-content_file_path'));
	$mode = $stat['mode'] & 0000777;	// Get the permission bits.

	if (!file_exists($wpcontent)){
		mkdir($wpcontent);
		chmod($wpcontent, $mode);
	}
	//mkdir(get_option('themes_file_path'));
	//chmod(get_option('themes_file_path'), $mode);

	//mkdir(get_option('plugins_file_path'));
	//chmod(get_option('plugins_file_path'), $mode);

	if (!file_exists(get_option('uploads_file_path'))){
		mkdir(get_option('uploads_file_path'));
		chmod(get_option('uploads_file_path'), $mode);
	}

	umask($old_umask);

	$slug = $wpdb->get_var("SELECT slug FROM $wpdb->blogs WHERE id = '$blog'");
	if (SUBDOMAINS)
		$home = 'http://' . $slug . '.' . MAINDOMAIN;
	else
		$home = LURL . '/' . $slug;
	add_option('siteurl', $home);
	add_option('blogname', __('My Weblog'), __('Blog title'));
	add_option('blogdescription', __('Just another Lyceum weblog'), __('Short tagline'));
	add_option('admin_email', 'you@example.com');
	add_option('start_of_week', 1);
	add_option('use_balanceTags', 0);
	add_option('use_smilies', 1);
	add_option('require_name_email', 1);
	add_option('comments_notify', 1);
	add_option('posts_per_rss', 10);
	add_option('rss_excerpt_length', 50);
	add_option('rss_use_excerpt', 0);
	add_option('mailserver_url', 'mail.example.com');
	add_option('mailserver_login', 'login@example.com');
	add_option('mailserver_pass', 'password');
	add_option('mailserver_port', 110);
	add_option('default_category');
	add_option('default_comment_status', 'open');
	add_option('default_ping_status', 'open');
	add_option('default_pingback_flag', 1);
	add_option('default_post_edit_rows', 10);
	add_option('posts_per_page', 10);
	add_option('what_to_show', 'posts');
	add_option('date_format', __('F j, Y'));
	add_option('time_format', __('g:i a'));
	add_option('links_updated_date_format', __('F j, Y g:i a'));
	add_option('links_recently_updated_prepend', '<em>');
	add_option('links_recently_updated_append', '</em>');
	add_option('links_recently_updated_time', 120);
	add_option('comment_moderation', 0);
	add_option('moderation_notify', 1);
	add_option('permalink_structure', DEFAULT_PS);
	add_option('hack_file', 0);
	add_option('blog_charset', 'UTF-8');
	add_option('moderation_keys');
	add_option('active_plugins');
	add_option('home', $home);
	add_option('category_base');
	add_option('ping_sites', '');
	add_option('advanced_edit', 0);
	add_option('comment_max_links', 2);
	add_option('gmt_offset', date('Z') / 3600);
	// 1.5
	add_option('default_email_category', 1, __('Posts by email go to this category'));
	add_option('recently_edited');
	add_option('use_linksupdate', 0);
	add_option('template', DEFAULT_TEMPLATE);
	add_option('stylesheet', DEFAULT_STYLESHEET);
	add_option('comment_whitelist', 1);
	add_option('page_uris');
	add_option('blacklist_keys');
	add_option('comment_registration', 0);
	add_option('open_proxy_check', 0);
	add_option('rss_language', 'en');
	add_option('html_type', 'text/html');
	// 1.5.1
	add_option('use_trackback', 0);
	// 2.0
	add_option('default_role', 'subscriber');
	add_option('rich_editing', 'true');
	// 2.0.1
//	populate_roles();
	
	// Set up a few options not to load by default
	$fatoptions = array( 'moderation_keys', 'recently_edited', 'blacklist_keys' );
	foreach ($fatoptions as $fatoption) :
		$wpdb->query("UPDATE $wpdb->options SET `autoload` = 'no' WHERE blog='$blog' AND option_name = '$fatoption'");
	endforeach;

	// Lyceum
	add_option('default_link_category', 0);
	add_option('comment_priviliges', 0);
}

function populate_system_options(){
	global $optiondomain, $wp_db_version, $wp_rewrite;
	$optiondomain = 'system';

	add_option('users_can_register', 1);
	add_option('gzipcompression', 0);
	add_option('db_version', $wp_db_version);
	add_option('wp-content_file_path', ABSPATH . "wp-content/blogs/");//lyceum administrator is responsible for creating this directory, and setting its permissions. the permissions of all subdirectories and files will mimick it.
	add_option('fileupload_base_url', LURL . '/wp-content/blogs/');
	add_option('email_structure', "/.*/");
	add_option('admin_ips', $_SERVER['REMOTE_ADDR'].','.$_SERVER['SERVER_ADDR'].',127.0.0.1');
	add_option('restrict_admin_ip', 0);
	add_option('active_system_plugins');
	add_option('system_charset', 'UTF-8');
	add_option('html_type', 'text/html');
	add_option('presentation_tab', 1);
	add_option('system_admin_email');
	add_option('import_allowed', 1);
	add_option('slug_blacklist', 'www,profile,login,register,index,availability,portal,private,readme,wp-atom,wp-blog-header,wp-comments-post,wp-commentsrss2,wp-feed,wp-login,wp-mail,wp-pass,wp-rdf,wp-register,wp-rss,wp-rss2,wp-trackback,xmlrpc');
	add_option('username_blacklist', 'lyceum,root');
	add_option('secret', md5(uniqid(microtime())));
	add_option('users_can_create_num_blogs', '0');
	add_option('users_can_create_blogs', '1');
	add_option('create_example_post', '1');
	add_option('create_example_page', '1');
	add_option('example_post_body', 'Welcome to ' . get_settings('site_title') . '. This is your first post. Edit or delete it, then start blogging!');
	add_option('example_page_body', 'This is an example of a page. You may make as many pages as you like, and even structure them in a hierarchy. It\'s quite possible that you won\'t find a use for pages at all. However, one page you may wish to create is an "About" page, telling your readers a little bit about yourself and what you like to write about. Just edit this page, rename the title to "About", and replace this text. Of course, you may also delete this page entirely if you wish.');
	add_option('example_post_title', 'Hello world!');
	add_option('example_page_title', 'About page example -- edit me!');
	add_option('new_user_welcome_message', 'Welcome to ' . get_settings('site_title'));
	add_option('new_blog_welcome_message', 'Your new blog has successfully been created');

	//// this is a little ugly
	$home_path = get_home_path();
	//$wp_rewrite->permalink_structure = DEFAULT_PS;
	$rules = explode("\n", $wp_rewrite->mod_rewrite_rules());
	insert_with_markers($home_path.'.htaccess', 'Lyceum', $rules);
	//////////////
}

function populate_roles() {
	populate_roles_160();	
}

function populate_roles_160() {
	global $wp_roles;

	// Add roles
	add_role('administrator', __('Administrator'));
	add_role('editor', __('Editor'));
	add_role('author', __('Author'));
	add_role('contributor', __('Contributor'));
	add_role('subscriber', __('Subscriber'));
	
	// Add caps for Administrator role
	$role = get_role('administrator');
	$role->add_cap('switch_themes');
	$role->add_cap('edit_themes');
	$role->add_cap('activate_plugins');
	$role->add_cap('edit_plugins');
	$role->add_cap('edit_users');
	$role->add_cap('edit_files');
	$role->add_cap('manage_options');
	$role->add_cap('moderate_comments');
	$role->add_cap('manage_categories');
	$role->add_cap('manage_links');
	$role->add_cap('upload_files');
	$role->add_cap('import');
	$role->add_cap('unfiltered_html');
	$role->add_cap('edit_posts');
	$role->add_cap('edit_others_posts');
	$role->add_cap('edit_published_posts');
	$role->add_cap('publish_posts');
	$role->add_cap('edit_pages');
	$role->add_cap('read');
	$role->add_cap('level_10');
	$role->add_cap('level_9');
	$role->add_cap('level_8');
	$role->add_cap('level_7');
	$role->add_cap('level_6');
	$role->add_cap('level_5');
	$role->add_cap('level_4');
	$role->add_cap('level_3');
	$role->add_cap('level_2');
	$role->add_cap('level_1');
	$role->add_cap('level_0');
	
	// Add caps for Editor role
	$role = get_role('editor');
	$role->add_cap('moderate_comments');
	$role->add_cap('manage_categories');
	$role->add_cap('manage_links');
	$role->add_cap('upload_files');
	$role->add_cap('unfiltered_html');
	$role->add_cap('edit_posts');
	$role->add_cap('edit_others_posts');
	$role->add_cap('edit_published_posts');
	$role->add_cap('publish_posts');
	$role->add_cap('edit_pages');
	$role->add_cap('read');
	$role->add_cap('level_7');
	$role->add_cap('level_6');
	$role->add_cap('level_5');
	$role->add_cap('level_4');
	$role->add_cap('level_3');
	$role->add_cap('level_2');
	$role->add_cap('level_1');
	$role->add_cap('level_0');
	
	// Add caps for Author role
	$role = get_role('author');
	$role->add_cap('upload_files');
	$role->add_cap('edit_posts');
	$role->add_cap('edit_published_posts');
	$role->add_cap('publish_posts');
	$role->add_cap('read');
	$role->add_cap('level_2');
	$role->add_cap('level_1');
	$role->add_cap('level_0');
	
	// Add caps for Contributor role
	$role = get_role('contributor');
	$role->add_cap('edit_posts');
	$role->add_cap('read');
	$role->add_cap('level_1');
	$role->add_cap('level_0');
	
	// Add caps for Subscriber role
	$role = get_role('subscriber');
	$role->add_cap('read');
	$role->add_cap('level_0');
}

?>
